Package org.apache.sysds.runtime.compress.colgroup

## Class ColGroupConst

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
    - - org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup
      - - org.apache.sysds.runtime.compress.colgroup.ColGroupConst

All Implemented Interfaces:
  `Serializable`, `AOffsetsGroup`, `IContainADictionary`, `IContainDefaultTuple`, `IMapToDataGroup`

    public class ColGroupConst
    extends ADictBasedColGroup
    implements IContainDefaultTuple, AOffsetsGroup, IMapToDataGroup

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `addToCommon​(double[] constV)` Take the values in this constant column group and add to the given constV.
`AColGroup` `append​(AColGroup g)` Append the other column group to this column group.
`AColGroup` `appendNInternal​(AColGroup[] g, int blen, int rlen)`
`AColGroup` `binaryRowOpLeft​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`AColGroup` `binaryRowOpRight​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`CM_COV_Object` `centralMoment​(CMOperator op, int nRows)` Central Moment instruction executed on a column group.
`void` `computeColSums​(double[] c, int nRows)` Compute the column sum
`boolean` `containsValue​(double pattern)` Detect if the column group contains a specific value.
`static AColGroup` `create​(double[] values)` Generate a constant column group.
`static AColGroup` `create​(int numCols, double value)` Generate a constant column group.
`static AColGroup` `create​(int numCols, IDictionary dict)` Generate a constant column group.
`static AColGroup` `create​(IColIndex cols, double value)` Generate a constant column group.
`static AColGroup` `create​(IColIndex cols, double[] values)` Generate a constant column group.
`static AColGroup` `create​(IColIndex colIndices, IDictionary dict)` Create constructor for a ColGroup Const this constructor ensures that if the dictionary input is empty an Empty column group is constructed.
`org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType` `getColGroupType()`
`CompressedSizeInfoColGroup` `getCompressionInfo​(int nRow)` Get the compression info for this column group.
`ICLAScheme` `getCompressionScheme()` Get the compression scheme for this column group to enable compression of other data.
`AColGroup.CompressionType` `getCompType()` Obtain the compression type.
`double` `getCost​(ComputationCostEstimator e, int nRows)` Get the computation cost associated with this column group.
`double[]` `getDefaultTuple()`
`IEncode` `getEncoding()` Get encoding of this column group.
`double` `getIdx​(int r, int colIdx)` Get the value at a colGroup specific row/column index position.
`AMapToData` `getMapToData()`
`long` `getNumberNonZeros​(int nRows)` Get the number of nonZeros contained in this column group.
`int` `getNumValues()` Obtain number of distinct tuples in contained sets of values associated with this column group.
`AOffset` `getOffsets()`
`double[]` `getValues()` Get dense values from colgroupConst.
`void` `leftMultByAColGroup​(AColGroup lhs, MatrixBlock result, int nRows)` Left side matrix multiplication with a column group that is transposed.
`void` `leftMultByMatrixNoPreAgg​(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)` Left multiply with this column group.
`static ColGroupConst` `read​(DataInput in)`
`AColGroup` `recompress()` Recompress this column group into a new column group.
`AColGroup` `replace​(double pattern, double replace)` Make a copy of the column group values, and replace all values that match pattern with replacement value.
`AColGroup` `rexpandCols​(int max, boolean ignore, boolean cast, int nRows)` Expand the column group to multiple columns.
`boolean` `sameIndexStructure​(AColGroupCompressed that)`
`AColGroup` `scalarOperation​(ScalarOperator op)` Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
`AColGroup` `sliceRows​(int rl, int ru)` Slice range of rows out of the column group and return a new column group only containing the row segment.
`String` `toString()`
`void` `tsmm​(double[] result, int numColumns, int nRows)`
`void` `tsmmAColGroup​(AColGroup other, MatrixBlock result)` Matrix multiply with this other column group, but: 1.
`AColGroup` `unaryOperation​(UnaryOperator op)` Perform unary operation on the column group and return a new column group

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup

`copyAndSet, copyAndSet, decompressToDenseBlock, decompressToSparseBlock, estimateInMemorySize, getDictionary, getExactSizeOnDisk, rightMultByMatrix, write`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, getSum, isEmpty, preAggRows, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`addVector, appendN, clear, colSum, combine, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getNumCols, morph, rightMultByMatrix, shiftColIndices, sliceColumn, sliceColumns, sortColumnIndexes`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### create

    public static AColGroup create​(IColIndex colIndices,
                                   IDictionary dict)

Create constructor for a ColGroup Const this constructor ensures that if the dictionary input is empty an Empty column group is constructed.

Parameters:
  `colIndices` - The column indexes in the column group
  `dict` - The dictionary to use
Returns:
  A Colgroup either const or empty.

#### create

    public static AColGroup create​(double[] values)

Generate a constant column group.

Parameters:
  `values` - The value vector that contains all the unique values for each column in the matrix.
Returns:
  A Constant column group.

#### create

    public static AColGroup create​(IColIndex cols,
                                   double value)

Generate a constant column group. It is assumed that the column group is intended for use, therefore zero value is allowed.

Parameters:
  `cols` - The specific column indexes that is contained in this constant group.
  `value` - The value contained in all cells.
Returns:
  A Constant column group.

#### create

    public static AColGroup create​(IColIndex cols,
                                   double[] values)

Generate a constant column group.

Parameters:
  `cols` - The specific column indexes that is contained in this constant group.
  `values` - The value vector that contains all the unique values for each column in the matrix.
Returns:
  A Constant column group.

#### create

    public static AColGroup create​(int numCols,
                                   IDictionary dict)

Generate a constant column group.

Parameters:
  `numCols` - The number of columns.
  `dict` - The dictionary to contain int the Constant group.
Returns:
  A Constant column group.

#### create

    public static AColGroup create​(int numCols,
                                   double value)

Generate a constant column group.

Parameters:
  `numCols` - The number of columns
  `value` - The value contained in all cells.
Returns:
  A Constant column group.

#### getValues

    public double[] getValues()

Get dense values from colgroupConst.

Returns:
  the dictionary vector stored in this column group

#### getCompType

    public AColGroup.CompressionType getCompType()

Description copied from class: `AColGroup`
Obtain the compression type.

Specified by:
  `getCompType` in class `AColGroup`
Returns:
  How the elements of the column group are compressed.

#### getColGroupType

    public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

#### getIdx

    public double getIdx​(int r,
                         int colIdx)

Description copied from class: `AColGroup`
Get the value at a colGroup specific row/column index position.

Specified by:
  `getIdx` in class `AColGroup`
Parameters:
  `r` - row
  `colIdx` - column index in the _colIndexes.
Returns:
  value at the row/column index position

#### scalarOperation

    public AColGroup scalarOperation​(ScalarOperator op)

Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Specified by:
  `scalarOperation` in class `AColGroup`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied

#### unaryOperation

    public AColGroup unaryOperation​(UnaryOperator op)

Description copied from class: `AColGroup`
Perform unary operation on the column group and return a new column group

Specified by:
  `unaryOperation` in class `AColGroup`
Parameters:
  `op` - The operation to perform
Returns:
  The new column group

#### binaryRowOpLeft

    public AColGroup binaryRowOpLeft​(BinaryOperator op,
                                     double[] v,
                                     boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpLeft` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### binaryRowOpRight

    public AColGroup binaryRowOpRight​(BinaryOperator op,
                                      double[] v,
                                      boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpRight` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply the values contained should be at least the length of the highest value in the column index
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### addToCommon

    public final void addToCommon​(double[] constV)

Take the values in this constant column group and add to the given constV. This allows us to completely ignore this column group for future calculations.

Parameters:
  `constV` - The output columns.

#### computeColSums

    public void computeColSums​(double[] c,
                               int nRows)

Description copied from class: `AColGroup`
Compute the column sum

Specified by:
  `computeColSums` in class `AColGroup`
Parameters:
  `c` - The array to add the column sum to.
  `nRows` - The number of rows in the column group.

#### getNumValues

    public int getNumValues()

Description copied from class: `AColGroup`
Obtain number of distinct tuples in contained sets of values associated with this column group. If the column group is uncompressed the number or rows is returned.

Specified by:
  `getNumValues` in class `AColGroup`
Returns:
  the number of distinct sets of values associated with the bitmaps in this column group

#### tsmm

    public void tsmm​(double[] result,
                     int numColumns,
                     int nRows)

#### leftMultByMatrixNoPreAgg

    public void leftMultByMatrixNoPreAgg​(MatrixBlock matrix,
                                         MatrixBlock result,
                                         int rl,
                                         int ru,
                                         int cl,
                                         int cu)

Description copied from class: `AColGroup`
Left multiply with this column group.

Specified by:
  `leftMultByMatrixNoPreAgg` in class `AColGroup`
Parameters:
  `matrix` - The matrix to multiply with on the left
  `result` - The result to output the values into, always dense for the purpose of the column groups parallelizing
  `rl` - The row to begin the multiplication from on the lhs matrix
  `ru` - The row to end the multiplication at on the lhs matrix
  `cl` - The column to begin the multiplication from on the lhs matrix
  `cu` - The column to end the multiplication at on the lhs matrix

#### leftMultByAColGroup

    public void leftMultByAColGroup​(AColGroup lhs,
                                    MatrixBlock result,
                                    int nRows)

Description copied from class: `AColGroup`
Left side matrix multiplication with a column group that is transposed.

Specified by:
  `leftMultByAColGroup` in class `AColGroup`
Parameters:
  `lhs` - The left hand side Column group to multiply with, the left hand side should be considered transposed. Also it should be guaranteed that this column group is not empty.
  `result` - The result matrix to insert the result of the multiplication into
  `nRows` - Number of rows in the lhs colGroup

#### tsmmAColGroup

    public void tsmmAColGroup​(AColGroup other,
                              MatrixBlock result)

Description copied from class: `AColGroup`
Matrix multiply with this other column group, but: 1. Only output upper triangle values. 2. Multiply both ways with "this" being on the left and on the right. It should be guaranteed that the input is not the same as the caller of the method. The second step is achievable by treating the initial multiplied matrix, and adding its values to the correct locations in the output.

Specified by:
  `tsmmAColGroup` in class `AColGroup`
Parameters:
  `other` - The other Column group to multiply with
  `result` - The result matrix to put the results into

#### containsValue

    public boolean containsValue​(double pattern)

Description copied from class: `AColGroup`
Detect if the column group contains a specific value.

Specified by:
  `containsValue` in class `AColGroup`
Parameters:
  `pattern` - The value to look for.
Returns:
  boolean saying true if the value is contained.

#### getNumberNonZeros

    public long getNumberNonZeros​(int nRows)

Description copied from class: `AColGroup`
Get the number of nonZeros contained in this column group.

Specified by:
  `getNumberNonZeros` in class `AColGroup`
Parameters:
  `nRows` - The number of rows in the column group, this is used for groups that does not contain information about how many rows they have.
Returns:
  The nnz.

#### replace

    public AColGroup replace​(double pattern,
                             double replace)

Description copied from class: `AColGroup`
Make a copy of the column group values, and replace all values that match pattern with replacement value.

Specified by:
  `replace` in class `AColGroup`
Parameters:
  `pattern` - The value to look for
  `replace` - The value to replace the other value with
Returns:
  A new Column Group, reusing the index structure but with new values.

#### centralMoment

    public CM_COV_Object centralMoment​(CMOperator op,
                                       int nRows)

Description copied from class: `AColGroup`
Central Moment instruction executed on a column group.

Specified by:
  `centralMoment` in class `AColGroup`
Parameters:
  `op` - The Operator to use.
  `nRows` - The number of rows contained in the ColumnGroup.
Returns:
  A Central Moment object.

#### rexpandCols

    public AColGroup rexpandCols​(int max,
                                 boolean ignore,
                                 boolean cast,
                                 int nRows)

Description copied from class: `AColGroup`
Expand the column group to multiple columns. (one hot encode the column group)

Specified by:
  `rexpandCols` in class `AColGroup`
Parameters:
  `max` - The number of columns to expand to and cutoff values at.
  `ignore` - If zero and negative values should be ignored.
  `cast` - If the double values contained should be cast to whole numbers.
  `nRows` - The number of rows in the column group.
Returns:
  A new column group containing max number of columns.

#### getCost

    public double getCost​(ComputationCostEstimator e,
                          int nRows)

Description copied from class: `AColGroup`
Get the computation cost associated with this column group.

Specified by:
  `getCost` in class `AColGroup`
Parameters:
  `e` - The computation cost estimator
  `nRows` - the number of rows in the column group
Returns:
  The cost of this column group

#### read

    public static ColGroupConst read​(DataInput in)
                              throws IOException

Throws:
  `IOException`

#### sliceRows

    public AColGroup sliceRows​(int rl,
                               int ru)

Description copied from class: `AColGroup`
Slice range of rows out of the column group and return a new column group only containing the row segment. Note that this slice should maintain pointers back to the original dictionaries and only modify index structures.

Specified by:
  `sliceRows` in class `AColGroup`
Parameters:
  `rl` - The row to start at
  `ru` - The row to end at (not included)
Returns:
  A new column group containing the specified row range.

#### append

    public AColGroup append​(AColGroup g)

Description copied from class: `AColGroup`
Append the other column group to this column group. This method tries to combine them to return a new column group containing both. In some cases it is possible in reasonable time, in others it is not. The result is first this column group followed by the other column group in higher row values. If it is not possible or very inefficient null is returned.

Specified by:
  `append` in class `AColGroup`
Parameters:
  `g` - The other column group
Returns:
  A combined column group or null

#### appendNInternal

    public AColGroup appendNInternal​(AColGroup[] g,
                                     int blen,
                                     int rlen)

#### getCompressionScheme

    public ICLAScheme getCompressionScheme()

Description copied from class: `AColGroup`
Get the compression scheme for this column group to enable compression of other data.

Specified by:
  `getCompressionScheme` in class `AColGroup`
Returns:
  The compression scheme of this column group

#### recompress

    public AColGroup recompress()

Description copied from class: `AColGroup`
Recompress this column group into a new column group.

Specified by:
  `recompress` in class `AColGroup`
Returns:
  A new or the same column group depending on optimization goal.

#### getCompressionInfo

    public CompressedSizeInfoColGroup getCompressionInfo​(int nRow)

Description copied from class: `AColGroup`
Get the compression info for this column group.

Specified by:
  `getCompressionInfo` in class `AColGroup`
Parameters:
  `nRow` - The number of rows in this column group.
Returns:
  The compression info for this group.

#### getEncoding

    public IEncode getEncoding()

Description copied from class: `AColGroup`
Get encoding of this column group.

Overrides:
  `getEncoding` in class `AColGroup`
Returns:
  The encoding of the index structure.

#### sameIndexStructure

    public boolean sameIndexStructure​(AColGroupCompressed that)

Specified by:
  `sameIndexStructure` in class `AColGroupCompressed`

#### getDefaultTuple

    public double[] getDefaultTuple()

Specified by:
  `getDefaultTuple` in interface `IContainDefaultTuple`

#### toString

    public String toString()

Overrides:
  `toString` in class `AColGroup`

#### getOffsets

    public AOffset getOffsets()

Specified by:
  `getOffsets` in interface `AOffsetsGroup`

#### getMapToData

    public AMapToData getMapToData()

Specified by:
  `getMapToData` in interface `IMapToDataGroup`